代码随想录算法训练营29期Day43|LeetCode 1049,494,474

文档讲解:最后一块石头的重量II 目标和 一和零

1049.最后一块石头的重量II

题目链接: https://leetcode.cn/problems/last-stone-weight-ii/description/

思路:

本题其实就是尽量让石头分成重量相同的两堆,相撞之后剩下的石头最小,这样就化解成01背包问题了。

本题物品的重量为stonesi,物品的价值也为stonesi。

对应着01背包里的物品重量weighti和 物品价值valuei。

最后dptarget里是容量为target的背包所能背的最大重量。

那么分成两堆石头,一堆石头的总重量是dptarget,另一堆就是sum - dptarget。

在计算target的时候,target = sum / 2 因为是向下取整,所以sum - dptarget 一定是大于等于dptarget的。

那么相撞之后剩下的最小石头重量就是 (sum - dptarget) - dptarget。

核心代码:

cpp 复制代码
class Solution {
public:
    int lastStoneWeightII(vector<int>& stones) {
        vector<int> dp(15001, 0);
        int sum = 0;
        for (int i = 0; i < stones.size(); i++) sum += stones[i];
        int target = sum / 2;
        for (int i = 0; i < stones.size(); i++) { // 遍历物品
            for (int j = target; j >= stones[i]; j--) { // 遍历背包
                dp[j] = max(dp[j], dp[j - stones[i]] + stones[i]);
            }
        }
        return sum - dp[target] - dp[target];
    }
};

494.目标和

题目链接: https://leetcode.cn/problems/target-sum/description/

思路:

假设加法的总和为x,那么减法对应的总和就是sum - x。

所以我们要求的是 x - (sum - x) = target

x = (target + sum) / 2

此时问题就转化为,装满容量为x的背包,有几种方法。

这里的x,就是bagSize,也就是我们后面要求的背包容量。

dpj 表示:填满j(包括j)这么大容积的包,有dpj种方法。有哪些来源可以推出dpj呢?只要搞到numsi,凑成dpj就有dpj - nums\[i] 种方法。

初始化一下借助状态转移方程就能做了。

核心代码:

cpp 复制代码
class Solution {
public:
    int findTargetSumWays(vector<int>& nums, int S) {
        int sum = 0;
        for (int i = 0; i < nums.size(); i++) sum += nums[i];
        if (abs(S) > sum) return 0; // 此时没有方案
        if ((S + sum) % 2 == 1) return 0; // 此时没有方案
        int bagSize = (S + sum) / 2;
        vector<int> dp(bagSize + 1, 0);
        dp[0] = 1;
        for (int i = 0; i < nums.size(); i++) {
            for (int j = bagSize; j >= nums[i]; j--) {
                dp[j] += dp[j - nums[i]];
            }
        }
        return dp[bagSize];
    }
};

474.一和零

题目链接: https://leetcode.cn/problems/ones-and-zeroes/description/

思路:

设dpij:最多有i个0和j个1的strs的最大子集的大小为dpij。

dpij 可以由前一个strs里的字符串推导出来,strs里的字符串有zeroNum个0,oneNum个1。

dpij 就可以是 dpi - zeroNumj - oneNum + 1。

然后我们在遍历的过程中,取dpij的最大值。

所以递推公式:dpij = max(dpij, dpi - zeroNumj - oneNum + 1);

dp数组初始化为0,递推即可。

核心代码:

cpp 复制代码
class Solution {
public:
    int findMaxForm(vector<string>& strs, int m, int n) {
        vector<vector<int>> dp(m + 1, vector<int> (n + 1, 0));
        for (string str : strs) {
            int oneNum = 0, zeroNum = 0;
            for (char c : str) {
                if (c == '0') zeroNum++;
                else oneNum++;
            }
            for (int i = m; i >= zeroNum; i--) {
                for (int j = n; j >= oneNum; j--) {
                    dp[i][j] = max(dp[i][j], dp[i - zeroNum][j - oneNum] + 1);
                }
            }
        }
        return dp[m][n];
    }
};

今日总结

今日学习时长2h,接着八股。

相关推荐
WL学习笔记33 分钟前
vector模拟实现
c++
蜗牛一步步往上爬3 小时前
第十六章 C++语言在深度学习中的应用
开发语言·c++·深度学习
文丑颜不良啊6 小时前
LeetCode2221~2240题目解析
java·leetcode
Navigator_Z6 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
wo_jack6 小时前
C++ 入门笔记(十六):第16课 vector 模拟实现十问十答 —— 从三指针到迭代器失效
c++·后端·面试·stl·vector
D e re k ZH7 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶8 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
文丑颜不良啊8 小时前
LeetCode2161~2180题目解析
java·leetcode
雪落漂泊8 小时前
C++算法 二分查找篇(上)
开发语言·c++·算法